package java.rmi.server;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.rmi.Remote;
import java.rmi.RemoteException;

public class UnicastRemoteObject extends RemoteServer {
   protected UnicastRemoteObject() throws RemoteException {
      exportObject(this);
   }

   private void readObject(ObjectInputStream var1) throws IOException, ClassNotFoundException {
      exportObject(this);
   }

   public Object clone() throws CloneNotSupportedException {
      try {
         UnicastRemoteObject var1 = (UnicastRemoteObject)super.clone();
         exportObject(var1);
         return var1;
      } catch (RemoteException var2) {
         throw new ServerCloneException("Clone failed", var2);
      }
   }

   public static RemoteStub exportObject(Remote var0) throws RemoteException {
      try {
         Class var1 = Class.forName(RemoteRef.packagePrefix + ".UnicastServerRef");
         Object var2 = var1.newInstance();
         if (var2 instanceof ServerRef) {
            ServerRef var3 = (ServerRef)var2;
            if (var0 instanceof UnicastRemoteObject) {
               ((UnicastRemoteObject)var0).ref = var3;
            }

            return var3.exportObject(var0, (Object)null);
         } else {
            throw new ExportException("Reference is not a java.rmi.server.ServerRef");
         }
      } catch (Exception var4) {
         throw new ExportException("Unable to create remote reference", var4);
      }
   }
}
